/*
 * Copyright [2022] [https://www.xiaonuo.vip]
 *
 * Snowy采用APACHE LICENSE 2.0开源协议，您在使用过程中，需要注意以下几点：
 *
 * 1.请不要删除和修改根目录下的LICENSE文件。
 * 2.请不要删除和修改Snowy源码头部的版权声明。
 * 3.本项目代码可免费商业使用，商业使用请保留源码和相关描述文件的项目出处，作者声明等。
 * 4.分发源码时候，请注明软件出处 https://www.xiaonuo.vip
 * 5.不可二次分发开源参与同类竞品，如有想法可联系团队xiaonuobase@qq.com商议合作。
 * 6.若您的项目无法满足以上几点，需要更多功能代码，获取Snowy商业授权许可，请在官网购买授权，地址为 https://www.xiaonuo.vip
 */
package vip.xiaonuo.disk.service.impl;


import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.springframework.stereotype.Service;
import vip.xiaonuo.auth.core.util.StpLoginUserUtil;
import vip.xiaonuo.disk.domain.Examine;
import vip.xiaonuo.disk.domain.UserFile;
import vip.xiaonuo.disk.dto.examine.ExamineReq;
import vip.xiaonuo.disk.mapper.ExamineMapper;
import vip.xiaonuo.disk.mapper.UserFileMapper;
import vip.xiaonuo.disk.service.ExamineService;
import vip.xiaonuo.disk.util.PageQuery;
import vip.xiaonuo.disk.util.TableDataInfo;
import vip.xiaonuo.disk.vo.examine.ExamineVo;

import javax.annotation.Resource;
import java.util.Date;
import java.util.Map;

/**
 * examineService接口实现类
 *
 * @author pans
 * @date  2025/06/19 11:21
 **/
@Service
public class ExamineServiceImpl extends ServiceImpl<ExamineMapper, Examine> implements ExamineService {
    @Resource
    private ExamineMapper examineMapper;
    @Resource
    private UserFileMapper userFileMapper;
    @Override
    public TableDataInfo<ExamineVo> queryList(ExamineReq examineReq, PageQuery pageQuery) {
        Page<ExamineVo> sclist=examineMapper.queryList(examineReq,pageQuery.build());
        return TableDataInfo.build(sclist);
    }

    @Override
    public void pass(Examine examine) {
        //修改审批记录里边的审核状态、审核时间、审核人
        String userId = StpLoginUserUtil.getLoginUser().getId();
        examine.setExamineUser(userId);
        examine.setExamineStatus("1");
        examine.setExamineTime(new Date());
        examineMapper.pass(examine);

        //修改主表中的审批状态
        UserFile userFile=new UserFile();
        userFile.setExamineStatus("1");
        userFile.setExamineUser(userId);
        userFile.setExamineTime(examine.getExamineTime());
        userFile.setExamineReason(examine.getExamineReason());
        userFile.setUserFileId(examine.getTargetId());
        userFileMapper.updateById(userFile);

    }

    @Override
    public void reject(Examine examine) {

        //修改审批记录里边的审核状态、审核时间、审核人
        String userId = StpLoginUserUtil.getLoginUser().getId();
        examine.setExamineUser(userId);
        examine.setExamineStatus("2");
        examine.setExamineTime(new Date());
        examineMapper.pass(examine);

        //修改主表中的审批状态
        UserFile userFile=new UserFile();
        userFile.setExamineStatus("2");
        userFile.setExamineUser(userId);
        userFile.setExamineTime(examine.getExamineTime());
        userFile.setExamineReason(examine.getExamineReason());
        userFile.setUserFileId(examine.getTargetId());
        userFileMapper.updateById(userFile);

    }

    @Override
    public Map<String, Object> detail(String userFileId) {
        return examineMapper.detail(userFileId);
    }
}
